//+-----------------------------------------------------------------+
//| Price Zone 1                                                    |
//| Original auther is unknown, modification by -IXI-.              |
//+-----------------------------------------------------------------+
//---- Indicator Settings
#property indicator_chart_window       // Locates indicator in chart window.
#property indicator_buffers 5          // Number of Buffers
#property indicator_color1  RoyalBlue
#property indicator_color2  Red
#property indicator_color3  Red
#property indicator_color4  LightSlateGray
#property indicator_color5  LightSlateGray
#property indicator_width1  2
#property indicator_width2  2
#property indicator_width3  2
#property indicator_width4  1
#property indicator_width5  1
//---- Input Parameters
extern int     Length     = 20;
extern double  Deviation  = 2.0;

//---- Buffers
double Middle[];
double MiddleI[];
double MiddleII[];
double Upper[];
double Lower[];
double HLMA[];
double CloseMA[];
double Slope[];

//+-------------------------------------------------------+
//| Custom Indicator Initialization Function              |
//+-------------------------------------------------------+
int init()
  {
   IndicatorBuffers(8);
   SetIndexBuffer(0,Middle);
   SetIndexBuffer(1,MiddleI);
   SetIndexBuffer(2,MiddleII);
   SetIndexBuffer(3,Upper);
   SetIndexBuffer(4,Lower);
   SetIndexBuffer(5,HLMA);
   SetIndexBuffer(6,CloseMA);
   SetIndexBuffer(7,Slope);
   IndicatorShortName("Price Zone("+Length+")");
   return(0);
  }

//+-------------------------------------------------------+
//| Custom Indicator Deinitialization Function            |
//+-------------------------------------------------------+
int deinit()
  {
   return(0);
  }
//+-------------------------------------------------------+
//| Price Zone                                            |
//+-------------------------------------------------------+
int start()
  {
   int I,II;
   double ClosePrice[];
   double HLPrice[];
   double APZRange = 0;
      
   ArrayResize(ClosePrice,0);
   ArrayResize(ClosePrice,ArraySize(Close));
   ArrayResize(HLPrice,ArraySize(High));
//---- Price Arrays
   for (int K = 0; K < ArraySize(ClosePrice); K++)
     {
      ClosePrice[K] = Close[ArraySize(ClosePrice)- 1 - K];
      HLPrice[K]= High[ArraySize(ClosePrice)-1-K]-Low[ArraySize(ClosePrice)-1-K];
     }
//---- Bar Counting
	int Counted = IndicatorCounted();
   if (Counted < 0)
      return(-1);
   I = MathMin(Bars-Counted,Bars-1);
   II = I;
   if (Slope[I]==-1)
      CleanPoint(I,MiddleI,MiddleII);
//---- Average Calculation
	while (I >=0)
	  {	
	   CloseMA[I] = iMAOnArray(ClosePrice,0,Length,0,MODE_EMA,I);
	   HLMA[I] = iMAOnArray(HLPrice,0,Length,0,MODE_EMA,I);
	   I--;
	  }
//---- Center and Border Lines
   I = II;
	while (I >= 0)
	  {
	   APZRange  = iMAOnArray(HLMA,0,Length,0,MODE_EMA,I);
	   Middle[I] = iMAOnArray(CloseMA,0,Length,0,MODE_EMA,I);
	   Upper[I]  = iMAOnArray(CloseMA,0,Length,0,MODE_EMA,I)+APZRange*Deviation;
	   Lower[I]  = iMAOnArray(CloseMA,0,Length,0,MODE_EMA,I)-APZRange*Deviation;
	   if (Middle[I] > Middle[I+1])
        Slope[I] = 1;
      if (Middle[I] < Middle[I+1])
        Slope[I] = -1;
      if (Slope[I] == -1)
        PlotPoint(I,MiddleI,MiddleII,Middle);
      I--;
     }
	return(0);
  }

//+-------------------------------------------------------+
//| User-Defined Functions                                |
//+-------------------------------------------------------+
//----- Cleaner
void CleanPoint(int i,double& first[],double& second[])
  {
   if ((second[i] != EMPTY_VALUE) && (second[i+1] != EMPTY_VALUE))
      second[i+1] = EMPTY_VALUE;
   else
      if ((first[i] != EMPTY_VALUE) && (first[i+1] != EMPTY_VALUE) && (first[i+2] == EMPTY_VALUE))
          first[i+1] = EMPTY_VALUE;
  }

//---- Plotter
void PlotPoint(int i,double& first[],double& second[],double& from[])
  {
   if (first[i+1] == EMPTY_VALUE)
      {
       if (first[i+2] == EMPTY_VALUE)
         {
          first[i]   = from[i];
          first[i+1] = from[i+1];
          second[i]  = EMPTY_VALUE;
         }
       else
         {
          second[i]   =  from[i];
          second[i+1] =  from[i+1];
          first[i]    = EMPTY_VALUE;
         }
      }
   else
      {
       first[i]  = from[i];
       second[i] = EMPTY_VALUE;
      }
  }